/********************************************************************************/
/*  Basecode for Discovery 32F4 board										  	*/
/*  Board: STM32F407 Discovery				             					  	*/
/*	COPYRIGHT (C) 2012		Ing. Thomas Winkler	<t.winkler@aon.at>				*/
/*  Built with CooCox CoIDE v1.5.0  											*/
/********************************************************************************/
/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License only.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   wrapper.h: wrapper from fatfs to stdio functions
*/

#ifndef FATFS_WRAPPER_H_
#define FATFS_WRAPPER_H_


#define	MAX_HANDLES			5			// maximal count of file handles


#include "ff.h"



#define	fopen(a,b)					(FILE *)__fopen(a,b)
#define	fclose(a)					__fclose((FIL *)a)
#define	ftell(fh)					f_tell((FIL *)fh)
#define	fseek(fh,offs,orig)			__fseek((FIL *)fh,offs,orig)
#define	fileno(fh)					__fileno((FIL *)fh)
#ifdef	feof
#undef	feof
#endif
#define	feof(fh)					__feof((FIL *)fh)
#define	fgetc(fh)					__fgetc((FIL *)fh)
#define	fgets(a,b,fh)				f_gets(a,b,(FIL *)fh)
#define	fputc(a,fh)					__fputc(a,(FIL *)fh)
#define	fputs(a,fh)					f_puts(a,(FIL *)fh)
#define	fread(a,b,c,fh)				__fread(a,b,c,(FIL *)fh)
#define	fwrite(a,b,c,fh)			__fwrite(a,b,c,(FIL *)fh)
#define	remove(a)					f_unlink(a)
#define	unlink(a)					f_unlink(a)
#define	fflush(fh)					(f_sync((FIL *)fh) == FR_OK ? 0 : EOF)



FATFS	*finit(void);

int		__fclose(FIL *stream);
FIL		*__fopen(const char *filename, const char *mode);
size_t	__fread(void *buffer, size_t size, size_t count, FIL *stream);
size_t	__fwrite(const void *buffer, size_t size, size_t count, FIL *stream);
int		__fseek(FIL *stream, long int offset, int origin);
long int __ftell(FIL *stream);
int		__fileno(FIL *stream);
int		__feof(FIL *stream);
//int 	__fputs(const char *string, FIL *stream);
int 	__fputc(int c, FIL *stream);
//char 	*__fgets (char *string, int n, FIL *stream);
int 	__fgetc(FIL *stream);
int		__remove ( const char * filename );


#endif
