/**********************************************************************************/
/*    Sample code for Discovery 32F4 board										  */
/*	  Board: STM32F407 Discovery				             					  */
/*    Manufacture: ST		                                                   	  */
/*	  COPYRIGHT (C) 2012														  */
/*    Designed by: Ing. Thomas Winkler			                                  */
/*    Built with CooCox CoIDE v1.5.0  					                          */
/**********************************************************************************/

#ifndef DISCOVERY_H_
#define DISCOVERY_H_

#include <stdio.h>
#include <stdarg.h>

#include "stm32f4xx.h"
#include "stm32f4xx_conf.h"



#define F_DIAG			1



#define LED_CNT		 	4
#define ALL_LEDS		0xf000


// 4 LED :: Port D, Pin 12-15
//
#define LED_PORT	 	GPIOD

#define LED_GREEN	 	GPIO_Pin_12
#define LED_ORANGE	 	GPIO_Pin_13
#define LED_RED		 	GPIO_Pin_14
#define LED_BLUE		GPIO_Pin_15


#define LED_LEFT	 	GPIO_Pin_12
#define LED_UP		 	GPIO_Pin_13
#define LED_RIGHT	 	GPIO_Pin_14
#define LED_DOWN		GPIO_Pin_15



#define	BUTTON_PORT		GPIOA
#define	BUTTON_B		GPIO_Pin_0					// PA0





// IEC bus output
//
#define IEC_OUT_GPIO_CLK    RCC_AHB1Periph_GPIOA
#define IEC_OUT			 	GPIOA

#define	IEC_DATAo			GPIO_Pin_1					// PA1
#define	IEC_CLKo			GPIO_Pin_8					// PA8
#define	IEC_ATNo			GPIO_Pin_15					// PA15


// IEC bus input
//
#define IEC_INP_GPIO_CLK    RCC_AHB1Periph_GPIOB
#define IEC_INP_EXTI		EXTI_PortSourceGPIOB
#define IEC_INP			 	GPIOB

#define	IEC_ATNi			GPIO_Pin_0					// PB0
#define	IEC_DATAi			GPIO_Pin_1					// PB1
#define	IEC_CLKi			GPIO_Pin_2					// PB2


/*
#define BUT_PORT	 	GPIOA
#define BUT1_PORT	 	GPIO_Pin_0
*/



void InitDiscovery(void);

void ResetLEDs(void);
void SetLED(uint16_t bitValue, int flg);


void delay_ms(uint16_t time);

void PrintDiagdata(void);


#endif
