/********************************************************************************/
/*	Basecode for 1541-Emul (floppy drive emulator)								*/
/*	Board: STM32F407 Discovery													*/
/*	COPYRIGHT (C) 2012		Ing. Thomas Winkler	<t.winkler@aon.at>				*/
/*  Built with CooCox CoIDE v1.5.0  											*/
/********************************************************************************/
/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License only.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   sTimer.h: soft timer, systick, delay management
*/

#ifndef __TIMER_H__
#define __TIMER_H__

#include "stm32f4xx.h"

//extern uint32_t MillisCounter;
//extern uint32_t MicrosCounter;


typedef volatile uint32_t	STIMER;

#define	SET_TIMER_MS(timer, delay)			timer = (Millis() + delay)
#define	CHK_TIMER_MS(timer)					((timer - Millis()) <= 0x80000000)

#define	SET_TIMER_US(timer, delay)			timer = (Micros() + delay)
#define	CHK_TIMER_US(timer)					((timer - Micros()) <= 0x80000000)




void ResetStimer(void);

void TimingDelay10us_Decrement(void);
//void TimingDelayMs_Decrement(void);

void Delay_Ms(__IO uint32_t nTime);
void Delay_us(__IO uint32_t nTime);

uint32_t Millis(void);
uint32_t Micros(void);


void InitStimer(void);

void TriggerTimer4(int scale);
uint32_t ReadTimer5(void);

#endif /* __DELAY_H__ */
